#= require slender_data/parameterizable


# Abstract base class for queries.
class slender_data.BaseQuery extends slender_data.Parameterizable

  # query_data: a hash containing the data of the query.
  constructor: (query_data, params) ->
    super params

    # Whether to return only full entries.
    #
    # If false, partial entries are also permitted as results.
    @full = query_data.full

    # The query that was given in the constructor.
    @given_query = query_data


  # Returns the key used in the given query.
  selector_name: ->
    @_selector_name_result or= Object.keys(@given_query)[0]


  # Returns the given selector value.
  selector_value: ->
    @given_query[@selector_name()]


  # Returns the hash representation of this query.
  to_hash: ->
    @given_query
